#! /usr/bin/env lua

-- Hello World!

require("lgui")
require("ldraw")

function expose(widget)
	local cr = ldraw.Context.createFromDrawable(widget:getWindow())
	local width, height = widget:getSize()
  
  	-- Clear the background
	cr:setSourceRgb(1, 1, 1)
	cr:paint()
	
	cr:selectFontFace("Sans", ldraw.FONT_SLANT_NORMAL, ldraw.FONT_WEIGHT_BOLD)
	
	-- Save the context (we will modify the font)
    cr:save()
      cr:setFontSize(40)
      cr:moveTo(40, 60)
      cr:setSourceRgb(0, 0, 0)
      cr:showText("Hello World")
    cr:restore()

    cr:setSourceRgb(1, 0, 0)
    cr:setFontSize(20)
    cr:moveTo(40, 100)
    cr:showText("Greetings from gtk and cairo")

	cr:setSourceRgb(0, 0, 1)
	cr:moveTo(0, 150)
	
	-- Draw the zig-zag thing
	local step = 10
	local lim = width / step
	
	for i = 0, lim do
		cr:relLineTo(5, step)
		cr:relLineTo(5, -step)
	end
	
	cr:stroke()
	cr:destroy()
end

local window = lgui.Window.new()
local canvas = lgui.DrawingArea.new()

canvas:set("width-request", 400, "height-request", 200)
window:set("title", "Hello World", "window-position", lgui.WIN_POS_CENTER)
window:add(canvas)
window:showAll()

window:connect("delete-event", lgui.quit)
canvas:connect("expose-event", expose, canvas)

window:showAll()
lgui.main()
