#! /usr/bin/env lua

-- Lines! Suports window resize.

require("lgui")
require("ldraw")

function expose(widget)
	local cr = ldraw.Context.createFromDrawable(widget:getWindow())
	local width, height = widget:getSize()

	-- Draw the background
	cr:setSourceRgb(1, 1, 1)
	cr:paint()

	-- Configure
	cr:setSourceRgb(0.1, 0.1, 1)
	cr:setLineCap(ldraw.LINE_CAP_ROUND)
	cr:setLineWidth(10)

	-- Draw some lines
	local h3 = height / 3

	cr:moveTo(20, 20)
	cr:lineTo(width, h3)
	cr:relLineTo(-width, h3)
	cr:relLineTo(width, h3)
	cr:stroke()

	cr:setSourceRgb(1, 0.1, 0.1)
	cr:setLineCap(ldraw.LINE_CAP_BUTT)
	cr:setLineWidth(5)

	cr:moveTo(width - 20, height - 20)
	cr:lineTo(0, 0)
	cr:lineTo(0, height)
	cr:lineTo(width, 0)
	cr:stroke()

	cr:destroy()
end

local window = lgui.Window.new()
window:set("title", "Lines demo", "window-position", lgui.WIN_POS_CENTER,
"app-paintable", true)
window:showAll()

window:connect("delete-event", lgui.quit)
window:connect("expose-event", expose, window, true)
window:connect("size-allocate", expose, window, true)


lgui.main()
