#! /usr/bin/env lua

-- Smile from http://www.tortall.net/mu/wiki/PyGTKCairoTutorial

require("lgui")
require("ldraw")

function expose(widget)
	local cr = ldraw.Context.createFromDrawable(widget:getWindow())
	local width , height = widget:getSize()

	cr:setSourceRgb(0.5, 0.5, 0.5)
	cr:rectangle(0, 0, width, height)
	cr:fill()

	-- Draw a rectangle
	cr:setSourceRgb(1.0, 1.0, 1.0)
	cr:rectangle(10, 10, width - 20, height - 20)
	cr:fill()

	-- Draw lines
	cr:setSourceRgb(0.0, 0.0, 0.8)
	cr:moveTo(width / 3.0, height / 3.0)
	cr:relLineTo(0, height / 6.0)
	cr:moveTo(2 * width / 3.0, height / 3.0)
	cr:relLineTo(0, height / 6.0)
	cr:stroke()

	-- And a circle
	local radius = math.min(width, height)

	cr:setSourceRgb(1.0, 0.0, 0.0)
	cr:arc(width / 2.0, height / 2.0, radius / 2.0 - 20, 0, 2 * math.pi)
	cr:stroke()
	cr:arc(width / 2.0, height / 2.0, radius / 3.0 - 10, math.pi / 3, 2 * math.pi / 3)
	cr:stroke()

	cr:destroy()
end

local window = lgui.Window.new()
window:set("title", "Smile!", "window-position", lgui.WIN_POS_CENTER,
"app-paintable", true)

window:connect("delete-event", lgui.quit)
window:connect("expose-event", expose, window)

window:showAll()
lgui.main()
